diff --git a/src/saveload/saveload.h b/src/saveload/saveload.h
--- a/src/saveload/saveload.h
+++ b/src/saveload/saveload.h
@@ -85,8 +85,63 @@
 	REF_STORAGE       = 9, ///< Load/save a reference to a persistent storage.
 };
 
-/** Highest possible savegame version. */
-#define SL_MAX_VERSION 255
+/**
+ * save/load versions used for the various branches / patches
+ */
+enum SaveLoadVersions {
+	BEFORE_ADDING_PATCHES_SL            = 185,
+	BACK_ONE_WAY_SIGNAL_SAFE_WAITING_SL = 186, // Back of one way signals is evil-deadlock.
+	TREE_GROWTH_RATE_SL                 = 188, // 
+	PROG_SIGS_SL                        = 189, // If Then Else signals ...
+	DAYLENGHT_SL                        = 190, // Daylenght
+	TOWN_CARGO_FACTOR_SL                = 191, // Generated town cargo amount
+	SL_RESERVATION                      = 192, // C
+	SL_CAPACITIES                       = 193, // A
+	SL_COMPONENTS                       = 194, // R
+	SL_DEMANDS                          = 195, // G
+	SL_MCF                              = 196, // O
+	SL_FLOWMAP                          = 197, // D
+	SL_CARGOMAP                         = 198, // I
+	SL_EXT_RATING                       = 199, // S (for T @see Keep compatible 8 :P )
+	TIMESEP_SV                          = 200, // Vehicles seperation
+	MORE_HEIGHTLEVEL_SAVEGAME_VERSION   = 201, // High high higher ...
+	KEEP_COMPATIBLE_1_SV                = 202, // 147 (with 147 no new chunks are introduced so no need to do the redeclaration trick)
+	KEEP_COMPATIBLE_2_SV                = 203, // 148
+	KEEP_COMPATIBLE_3_SV                = 204, // 148
+	KEEP_COMPATIBLE_4_SV                = 205, // 149
+	KEEP_COMPATIBLE_5_SV                = 206, // 150
+	KEEP_COMPATIBLE_6_SV                = 206, // MORE_HEIGHTLEVEL_SAVEGAME_VERSION(disaster-vehicle_sl)
+	KEEP_COMPATIBLE_7_SV                = 206, // 151
+	KEEP_COMPATIBLE_8_SV                = 207, // CargoDist SL_CAPACITIES(last_loading_station)
+	INGAME_TREELINE_SV                  = 208, // Fix treeline for old games (and have it configurable ingame at the same time ;) )
+	KEEP_COMPATIBLE_9_SV                = 209, // 151 (vehicle_sl-> CONDNULL)
+	KEEP_COMPATIBLE_10_SV               = 210, // 152
+	KEEP_COMPATIBLE_11_SV               = 210, // 153
+	IS_SL                               = 211, // Infrastructure sharing
+	EXCLUSIVE_DL_SL                     = 212, // Adjust exclusive counter to daylenght in town_sl.cpp
+	KEEP_COMPATIBLE_12_SV               = 213, // 154
+	KEEP_COMPATIBLE_13_SV               = 214, // 155
+	KEEP_COMPATIBLE_14_SV               = 215, // 156
+	KEEP_COMPATIBLE_15_SV               = 216, // 157
+	KEEP_COMPATIBLE_16_SV               = 217, // 158
+	KEEP_COMPATIBLE_17_SV               = 218, // 159
+	KEEP_COMPATIBLE_18_SV               = 219, // 160
+	KEEP_COMPATIBLE_19_SV               = 220, // 160
+	KEEP_COMPATIBLE_20_SV               = 221, // Save ticks per minute (departure boards)
+	SL_IB                               = 222, // Improved breakdowns
+	TL_SV                               = 223, // Trafficlights
+	TOWN_GROWTH_SV                      = 224, // Town growth needs goods
+	DESERT_SV                           = 225, // Amount of desert selectable (not sure if this needs to be saved but it does not hurt ...)
+	KEEP_COMPATIBLE_21_SV               = 226, // TOWN_GROWTH_SV -> saving larger towns values
+	SPEED_SIGNALS_SV                    = 227, // Speed signals (based on progsigs patch)
+	KEEP_COMPATIBLE_22_SV               = 228, // No linkgraph overloading (extension to CargoDist).
+	KEEP_COMPATIBLE_23_SV               = 229, // Advanced setting for industrie placement (More Height Levels)
+	KEEP_COMPATIBLE_24_SV               = 230, // TL_SV -> Advanced setting for selecting distance between trafficlights in a syncronised consist.
+	TREEDRAG_SV                         = 231, // Configurable drag limit for trees.
+
+	/** Highest possible savegame version. */
+	SL_MAX_VERSION                      = 255
+};
 
 /** Flags of a chunk. */
 enum ChunkType {
diff --git a/src/saveload/saveload_internal.h b/src/saveload/saveload_internal.h
--- a/src/saveload/saveload_internal.h
+++ b/src/saveload/saveload_internal.h
@@ -30,6 +30,7 @@
 void AfterLoadStations();
 void AfterLoadRoadStops();
 void AfterLoadLabelMaps();
+void AfterLoadLinkGraphs();
 void UpdateHousesAndTowns();
 
 void UpdateOldAircraft();
diff --git a/src/saveload/signal_sl.cpp b/src/saveload/signal_sl.cpp
new file mode 100644
--- /dev/null
+++ b/src/saveload/signal_sl.cpp
@@ -0,0 +1,341 @@
+/* $Id$ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file signal_sl.cpp Code handling saving and loading of signals */
+
+#include "../stdafx.h"
+#include "../programmable_signals.h"
+#include "../core/alloc_type.hpp"
+#include "../core/bitmath_func.hpp"
+#include <vector>
+#include "saveload.h"
+
+typedef std::vector<byte> Buffer;
+
+/* Variable length integers are stored in Variable Length Quantity
+ * format (http://en.wikipedia.org/wiki/Variable-length_quantity). */
+
+static void WriteVLI(Buffer &b, uint i)
+{
+    uint lsmask =  0x7F;
+    uint msmask = ~0x7F;
+    while(i & msmask) {
+        byte part = (i & lsmask) | 0x80;
+        b.push_back(part);
+        i >>= 7;
+    }
+    b.push_back((byte) i);
+}
+
+static uint ReadVLI()
+{
+    uint shift = 0;
+		uint val = 0;
+    byte b;
+
+    b = SlReadByte();
+    while(b & 0x80) {
+        val |= uint(b & 0x7F) << shift;
+        shift += 7;
+        b = SlReadByte();
+    }
+    val |= uint(b) << shift;
+    return val;
+}
+
+static void WriteCondition(Buffer &b, SignalCondition *c)
+{
+	WriteVLI(b, c->ConditionCode());
+	switch(c->ConditionCode()) {
+		case PSC_NUM_GREEN:
+		case PSC_NUM_RED: {
+			SignalVariableCondition *vc = static_cast<SignalVariableCondition*>(c);
+			WriteVLI(b, vc->comparator);
+			WriteVLI(b, vc->value);
+		} break;
+		
+		case PSC_SIGNAL_STATE: {
+			SignalStateCondition *sc = static_cast<SignalStateCondition*>(c);
+			WriteVLI(b, sc->sig_tile);
+			WriteVLI(b, sc->sig_track);
+		} break;
+		
+		default:
+			break;
+	}
+}
+
+static SignalCondition *ReadCondition(SignalReference this_sig)
+{
+	SignalConditionCode code = (SignalConditionCode) ReadVLI();
+	switch(code) {
+		case PSC_NUM_GREEN:
+		case PSC_NUM_RED: {
+			SignalVariableCondition *c = new SignalVariableCondition(code);
+			c->comparator = (SignalComparator) ReadVLI();
+			if(c->comparator > SGC_LAST) NOT_REACHED();
+			c->value = ReadVLI();
+			return c;
+		}
+		
+		case PSC_SIGNAL_STATE: {
+			TileIndex ti = (TileIndex) ReadVLI();
+			Trackdir  td = (Trackdir) ReadVLI();
+			return new SignalStateCondition(this_sig, ti, td);
+		}
+		
+		default:
+			return new SignalSimpleCondition(code);
+	}
+}
+
+static void Save_SPRG()
+{
+	/* Check for, and dispose of, any signal information on a tile which doesn't have signals.
+	 * This indicates that someone removed the signals from the tile but didn't clean them up.
+	 * (This code is to detect bugs and limit their consquences, not to cover them up!) */
+	for(ProgramList::iterator i = _signal_programs.begin(), e = _signal_programs.end();
+			i != e; ++i) {
+		SignalReference ref = i->first;
+		if(!HasProgrammableSignals(ref)) {
+			DEBUG(sl, 0, "Programmable signal information for (%x, %d) has been leaked!",
+						ref.tile, ref.track);
+			++i;
+			FreeSignalProgram(ref);
+			if(i == e) break;
+		}
+	}
+	
+	/* OK, we can now write out our programs. */
+	Buffer b;
+	WriteVLI(b, _signal_programs.size());
+	for(ProgramList::iterator i = _signal_programs.begin(), e = _signal_programs.end();
+			i != e; ++i) {
+		SignalReference ref = i->first;
+		SignalProgram *prog = i->second;
+	
+		prog->DebugPrintProgram();
+	
+		WriteVLI(b, prog->tile);
+		WriteVLI(b, prog->track);
+		WriteVLI(b, prog->instructions.Length());
+		for(SignalInstruction **j = prog->instructions.Begin(), **je = prog->instructions.End();
+				j != je; ++j) {
+			SignalInstruction *insn = *j;
+			WriteVLI(b, insn->Opcode());
+			if(insn->Opcode() != PSO_FIRST)
+				WriteVLI(b, insn->Previous()->Id());
+			switch(insn->Opcode()) {
+				case PSO_FIRST: {
+					SignalSpecial *s = static_cast<SignalSpecial*>(insn);
+					WriteVLI(b, s->next->Id());
+					break;
+				}
+				
+				case PSO_LAST: break;
+				
+				case PSO_IF: {
+					SignalIf *i = static_cast<SignalIf*>(insn);
+					WriteCondition(b, i->condition);
+					WriteVLI(b, i->if_true->Id()); 
+					WriteVLI(b, i->if_false->Id());
+					WriteVLI(b, i->after->Id());
+					break;
+				}
+				
+				case PSO_IF_ELSE:
+				case PSO_IF_ENDIF: {
+					SignalIf::PseudoInstruction *p = static_cast<SignalIf::PseudoInstruction*>(insn);
+					WriteVLI(b, p->block->Id());
+					break;
+				}
+				
+				case PSO_SET_SIGNAL: {
+					SignalSet *s = static_cast<SignalSet*>(insn);
+					WriteVLI(b, s->next->Id());
+					WriteVLI(b, s->to_state ? 1 : 0);
+					break;
+				}
+				
+				default: NOT_REACHED();
+			}
+		}
+	}
+	
+	uint size = b.size();
+	SlSetLength(size);
+	for(uint i = 0; i < size; i++)
+		SlWriteByte(b[i]); // TODO Gotta be a better way
+}
+
+static void Load_SSIG()
+{
+	_speedlimits.clear();
+
+	uint count = ReadVLI();
+	for(uint i = 0; i < count; i++) {
+		TileIndex tile    = ReadVLI();
+		Track     track   = (Track) ReadVLI();
+		uint16 speed = ReadVLI();
+		SignalReference ref(tile, track);
+
+		_speedlimits[ref] = speed;
+	}
+}
+
+static void Save_SSIG()
+{
+	/* Check for, and dispose of, any signal information on a tile which doesn't have signals.
+	 * This indicates that someone removed the signals from the tile but didn't clean them up.
+	 * (This code is to detect bugs and limit their consquences, not to cover them up!) */
+	for(SpeedLimits::iterator i = _speedlimits.begin(), e = _speedlimits.end();
+			i != e; ++i) {
+		SignalReference ref = i->first;
+		if(!HasSpeedSignals(ref)) {
+			DEBUG(sl, 0, "Speed signal information for (%x, %d) has been leaked!",
+						ref.tile, ref.track);
+			++i;
+			FreeSignalSpeed(ref);
+			if(i == e) break;
+		}
+	}
+
+	/* OK, we can now write out our speed limits. */
+	Buffer b;
+	WriteVLI(b, _speedlimits.size());
+	for(SpeedLimits::iterator i = _speedlimits.begin(), e = _speedlimits.end();
+			i != e; ++i) {
+		SignalReference ref = i->first;
+		uint16 speed = i->second;
+
+		WriteVLI(b, ref.tile);
+		WriteVLI(b, ref.track);
+		WriteVLI(b, speed);
+	}
+
+	uint size = b.size();
+	SlSetLength(size);
+	for(uint i = 0; i < size; i++)
+		SlWriteByte(b[i]); // TODO Gotta be a better way.
+}
+
+/* We don't know the pointer values that need to be stored in various 
+ * instruction fields at load time, so we need to instead store the IDs and
+ * then fix them up once all of the instructions have been loaded.
+ *
+ * Additionally, we store the opcode type we expect (if we expect a specific one)
+ * to check for consistency (For example, an If Pseudo Instruction's block should
+ * point at an If!) */
+struct Fixup {
+	Fixup(SignalInstruction **p, SignalOpcode type)
+		: type(type), ptr(p)
+	{}
+	
+	SignalOpcode type;
+	SignalInstruction **ptr;
+};
+
+typedef SmallVector<Fixup, 4> FixupList;
+
+template<typename T>
+static void MakeFixup(FixupList &l, T *&ir, uint id, SignalOpcode op = PSO_INVALID)
+{
+	ir = reinterpret_cast<T*>(id);
+	new(l.Append()) Fixup(reinterpret_cast<SignalInstruction**>(&ir), op);
+}
+
+static void DoFixups(FixupList &l, InstructionList &il)
+{
+	for(Fixup *i = l.Begin(), *e = l.End(); i != e; ++i) {
+		uint id = reinterpret_cast<size_t>(*i->ptr);
+		if(id >= il.Length())
+			NOT_REACHED();
+			
+		*i->ptr = il[id];
+		
+		if(i->type != PSO_INVALID && (*i->ptr)->Opcode() != i->type) {
+			DEBUG(sl, 0, "Expected Id %d to be %d, but was in fact %d", id, i->type, (*i->ptr)->Opcode());
+			NOT_REACHED();
+		}
+	}
+}
+
+static void Load_SPRG()
+{
+	uint count = ReadVLI();
+	for(uint i = 0; i < count; i++) {
+		FixupList l;
+		TileIndex tile    = ReadVLI();
+		Track     track   = (Track) ReadVLI();
+		uint instructions = ReadVLI();
+		SignalReference ref(tile, track);
+		
+		SignalProgram *sp = new SignalProgram(tile, track, true);
+		_signal_programs[ref] = sp;
+		
+		for(uint j = 0; j < instructions; j++) {
+			SignalOpcode op = (SignalOpcode) ReadVLI();
+			switch(op) {
+				case PSO_FIRST: {
+					sp->first_instruction = new SignalSpecial(sp, PSO_FIRST);
+					sp->first_instruction->GetPrevHandle() = NULL;
+					MakeFixup(l, sp->first_instruction->next, ReadVLI());
+					break;
+				}
+				
+				case PSO_LAST: {
+					sp->last_instruction = new SignalSpecial(sp, PSO_LAST);
+					sp->last_instruction->next = NULL;
+					MakeFixup(l, sp->last_instruction->GetPrevHandle(), ReadVLI());
+					break;
+				}
+				
+				case PSO_IF: {
+					SignalIf *i = new SignalIf(sp, true);
+					MakeFixup(l, i->GetPrevHandle(), ReadVLI());
+					i->condition = ReadCondition(ref);
+					MakeFixup(l, i->if_true,  ReadVLI()); 
+					MakeFixup(l, i->if_false, ReadVLI()); 
+					MakeFixup(l, i->after, ReadVLI()); 
+					break;
+				}
+				
+				case PSO_IF_ELSE:
+				case PSO_IF_ENDIF: {
+					SignalIf::PseudoInstruction *p = new SignalIf::PseudoInstruction(sp, op);
+					MakeFixup(l, p->GetPrevHandle(), ReadVLI());
+					MakeFixup(l, p->block, ReadVLI(), PSO_IF);
+					break;
+				}
+				
+				case PSO_SET_SIGNAL: {
+					SignalSet *s = new SignalSet(sp);
+					MakeFixup(l, s->GetPrevHandle(), ReadVLI());
+					MakeFixup(l, s->next, ReadVLI());
+					s->to_state = (SignalState) ReadVLI();
+					if(s->to_state > SIGNAL_STATE_MAX) NOT_REACHED();
+					break;
+				}
+				
+				default: NOT_REACHED();
+			}
+		}
+		
+		DoFixups(l, sp->instructions);
+		sp->DebugPrintProgram();
+	}
+}
+
+extern const ChunkHandler _signal_chunk_handlers[] = {
+	{ 'SPRG', Save_SPRG, Load_SPRG, NULL, NULL, CH_RIFF | CH_LAST},
+};
+
+extern const ChunkHandler _speed_signal_chunk_handlers[] = {
+	{ 'SSIG', Save_SSIG, Load_SSIG, NULL, NULL, CH_RIFF | CH_LAST},
+};
diff --git a/src/saveload/station_sl.cpp b/src/saveload/station_sl.cpp
--- a/src/saveload/station_sl.cpp
+++ b/src/saveload/station_sl.cpp
@@ -225,9 +225,11 @@
 };
 
 static uint16 _waiting_acceptance;
+static uint16 _num_links;
+static uint32 _num_flows;
 static uint16 _cargo_source;
 static uint32 _cargo_source_xy;
-static uint16 _cargo_days;
+static uint8  _cargo_days;
 static Money  _cargo_feeder_share;
 
 static const SaveLoad _station_speclist_desc[] = {
@@ -237,6 +239,49 @@
 	SLE_END()
 };
 
+static StationID _station_id;
+
+/**
+ * Wrapper function to get the LinkStat's internal structure while
+ * some of the variables are private.
+ * @return Saveload description for LinkStat.
+ */
+const SaveLoad *GetLinkStatDesc()
+{
+	static const SaveLoad linkstat_desc[] = {
+		SLEG_CONDVAR(             _station_id,         SLE_UINT16,      SL_CAPACITIES, SL_MAX_VERSION),
+		 SLE_CONDVAR(LinkStat,    length,              SLE_UINT32,      SL_CAPACITIES, SL_MAX_VERSION),
+		 SLE_CONDVAR(LinkStat,    capacity,            SLE_UINT32,      SL_CAPACITIES, SL_MAX_VERSION),
+		 SLE_CONDVAR(LinkStat,    frozen,              SLE_UINT32,      SL_CAPACITIES, SL_MAX_VERSION),
+		 SLE_CONDVAR(LinkStat,    usage,               SLE_UINT32,      SL_CAPACITIES, SL_MAX_VERSION),
+		 SLE_END()
+	};
+	
+	return linkstat_desc;
+}
+
+/**
+ * Wrapper function to get the FlowStats's internal structure while
+ * some of the variables are private.
+ * @return Saveload description for FlowStat.
+ */
+const SaveLoad *GetFlowStatDesc()
+{
+	static const SaveLoad _flowstat_desc[] = {
+		SLEG_CONDVAR(             _station_id,         SLE_UINT16,         SL_FLOWMAP, SL_MAX_VERSION),
+		 SLE_CONDVAR(FlowStat,    via,                 SLE_UINT16,         SL_FLOWMAP, SL_MAX_VERSION),
+		 SLE_CONDVAR(FlowStat,    length,              SLE_UINT32,         SL_FLOWMAP, SL_MAX_VERSION),
+		 SLE_CONDVAR(FlowStat,    planned,             SLE_UINT32,         SL_FLOWMAP, SL_MAX_VERSION),
+		 SLE_CONDVAR(FlowStat,    sent,                SLE_UINT32,         SL_FLOWMAP, SL_MAX_VERSION),
+		 SLE_END()
+	};
+
+	return _flowstat_desc;
+}
+
+std::list<CargoPacket *> _packets;
+uint32 _num_dests;
+
 /**
  * Wrapper function to get the GoodsEntry's internal structure while
  * some of the variables itself are private.
@@ -258,15 +303,51 @@
 		     SLE_VAR(GoodsEntry, last_age,            SLE_UINT8),
 		SLEG_CONDVAR(            _cargo_feeder_share, SLE_FILE_U32 | SLE_VAR_I64, 14, 64),
 		SLEG_CONDVAR(            _cargo_feeder_share, SLE_INT64,                  65, 67),
-		 SLE_CONDVAR(GoodsEntry, amount_fract,        SLE_UINT8,                 150, SL_MAX_VERSION),
-		 SLE_CONDLST(GoodsEntry, cargo.packets,       REF_CARGO_PACKET,           68, SL_MAX_VERSION),
-
+		 SLE_CONDVAR(GoodsEntry, amount_fract,        SLE_UINT8,                 150, BEFORE_ADDING_PATCHES_SL),
+		 SLE_CONDVAR(GoodsEntry, amount_fract,        SLE_UINT8,                 KEEP_COMPATIBLE_5_SV, SL_MAX_VERSION),
+		SLEG_CONDLST(            _packets,            REF_CARGO_PACKET,           68, SL_CARGOMAP - 1),
+		SLEG_CONDVAR(            _num_dests,          SLE_UINT32,        SL_CARGOMAP, SL_MAX_VERSION),
+		 SLE_CONDVAR(GoodsEntry, supply,              SLE_UINT32,      SL_CAPACITIES, SL_MAX_VERSION),
+		 SLE_CONDVAR(GoodsEntry, supply_new,          SLE_UINT32,      SL_CAPACITIES, SL_MAX_VERSION),
+		SLEG_CONDVAR(            _num_links,          SLE_UINT16,      SL_CAPACITIES, SL_MAX_VERSION),
+		SLEG_CONDVAR(            _num_flows,          SLE_UINT32,         SL_FLOWMAP, SL_MAX_VERSION),
+		 SLE_CONDVAR(GoodsEntry, last_component,      SLE_UINT16,      SL_COMPONENTS, SL_MAX_VERSION),
+		 SLE_CONDVAR(GoodsEntry, max_waiting_cargo,   SLE_UINT32,      SL_EXT_RATING, SL_MAX_VERSION),
 		SLE_END()
 	};
 
 	return goods_desc;
 }
 
+typedef std::pair<const StationID, std::list<CargoPacket *> > StationCargoPair;
+
+static const SaveLoad _cargo_list_desc[] = {
+	SLE_VAR(StationCargoPair, first,  SLE_UINT16),
+	SLE_LST(StationCargoPair, second, REF_CARGO_PACKET),
+	SLE_END()
+};
+
+/**
+ * swap the temporary packets with the packets without specific destination in
+ * the given goods entry. Assert that at least one of those is empty.
+ * @param ge the goods entry to swap with
+ */
+static void SwapPackets(GoodsEntry *ge)
+{
+	StationCargoPacketMap &ge_packets = const_cast<StationCargoPacketMap &>(*ge->cargo.Packets());
+
+	if (_packets.empty()) {
+		std::map<StationID, std::list<CargoPacket *> >::iterator it(ge_packets.find(INVALID_STATION));
+		if (it == ge_packets.end()) {
+			return;
+		} else {
+			it->second.swap(_packets);
+		}
+	} else {
+		assert(ge_packets[INVALID_STATION].empty());
+		ge_packets[INVALID_STATION].swap(_packets);
+	}
+}
 
 static void Load_STNS()
 {
@@ -282,6 +363,7 @@
 		for (CargoID i = 0; i < num_cargo; i++) {
 			GoodsEntry *ge = &st->goods[i];
 			SlObject(ge, GetGoodsDesc());
+			SwapPackets(ge);
 			if (IsSavegameVersionBefore(68)) {
 				SB(ge->acceptance_pickup, GoodsEntry::GES_ACCEPTANCE, 1, HasBit(_waiting_acceptance, 15));
 				if (GB(_waiting_acceptance, 0, 12) != 0) {
@@ -293,8 +375,11 @@
 					 * savegame versions. As the CargoPacketPool has more than
 					 * 16 million entries; it fits by an order of magnitude. */
 					assert(CargoPacket::CanAllocateItem());
-					ge->cargo.Append(new CargoPacket(GB(_waiting_acceptance, 0, 12), _cargo_days, source, _cargo_source_xy, _cargo_source_xy, _cargo_feeder_share));
-					SB(ge->acceptance_pickup, GoodsEntry::GES_PICKUP, 1, 1);
+
+					/* Don't construct the packet with station here, because that'll fail with old savegames */
+					CargoPacket *cp = new CargoPacket(GB(_waiting_acceptance, 0, 12), _cargo_days, source, _cargo_source_xy, _cargo_source_xy, _cargo_feeder_share);
+					ge->cargo.Append(INVALID_STATION, cp);
+ 					SB(ge->acceptance_pickup, GoodsEntry::GES_PICKUP, 1, 1);
 				}
 			}
 		}
@@ -319,7 +404,9 @@
 		if (!IsSavegameVersionBefore(68)) {
 			for (CargoID i = 0; i < NUM_CARGO; i++) {
 				GoodsEntry *ge = &st->goods[i];
+				SwapPackets(ge);
 				SlObject(ge, GetGoodsDesc());
+				SwapPackets(ge);
 			}
 		}
 		SlObject(st, _old_station_desc);
@@ -409,8 +496,29 @@
 
 	if (!waypoint) {
 		Station *st = Station::From(bst);
-		for (CargoID i = 0; i < NUM_CARGO; i++) {
-			SlObject(&st->goods[i], GetGoodsDesc());
+		for (CargoID c = 0; c < NUM_CARGO; c++) {
+			_num_dests = (uint32)st->goods[c].cargo.Packets()->MapSize();
+			_num_links = (uint16)st->goods[c].link_stats.size();
+			_num_flows = 0;
+			for (FlowStatMap::const_iterator it(st->goods[c].flows.begin()); it != st->goods[c].flows.end(); ++it) {
+				_num_flows += (uint32)it->second.size();
+			}
+			SlObject(&st->goods[c], GetGoodsDesc());
+			for (LinkStatMap::const_iterator it(st->goods[c].link_stats.begin()); it != st->goods[c].link_stats.end(); ++it) {
+				_station_id = it->first;
+				LinkStat ls(it->second); // make a copy to avoid constness problems
+				SlObject(&ls, GetLinkStatDesc());
+			}
+			for (FlowStatMap::const_iterator outer_it(st->goods[c].flows.begin()); outer_it != st->goods[c].flows.end(); ++outer_it) {
+				_station_id = outer_it->first;
+				for (FlowStatSet::const_iterator inner_it(outer_it->second.begin()); inner_it != outer_it->second.end(); ++inner_it) {
+					FlowStat fs(*inner_it); // make a copy to avoid constness problems
+					SlObject(&fs, GetFlowStatDesc());
+				}
+			}
+			for (StationCargoPacketMap::ConstMapIterator it(st->goods[c].cargo.Packets()->begin()); it != st->goods[c].cargo.Packets()->end(); ++it) {
+				SlObject(const_cast<StationCargoPacketMap::value_type *>(&(*it)), _cargo_list_desc);
+			}
 		}
 	}
 
@@ -474,7 +582,16 @@
 	FOR_ALL_STATIONS(st) {
 		for (CargoID i = 0; i < NUM_CARGO; i++) {
 			GoodsEntry *ge = &st->goods[i];
-			SlObject(ge, GetGoodsDesc());
+			if (IsSavegameVersionBefore(SL_CARGOMAP)) {
+				SwapPackets(ge);
+				SlObject(ge, GetGoodsDesc());
+				SwapPackets(ge);
+			} else {
+				SlObject(ge, GetGoodsDesc());
+				for (StationCargoPacketMap::ConstMapIterator it = ge->cargo.Packets()->begin(); it != ge->cargo.Packets()->end(); ++it) {
+					SlObject(const_cast<StationCargoPair *>(&(*it)), _cargo_list_desc);
+				}
+			}
 		}
 		SlObject(st, _station_desc);
 	}
diff --git a/src/saveload/town_sl.cpp b/src/saveload/town_sl.cpp
--- a/src/saveload/town_sl.cpp
+++ b/src/saveload/town_sl.cpp
@@ -165,7 +165,8 @@
 	    SLE_VAR(Town, road_build_months,     SLE_UINT8),
 
 	SLE_CONDVAR(Town, exclusivity,           SLE_UINT8,                  2, SL_MAX_VERSION),
-	SLE_CONDVAR(Town, exclusive_counter,     SLE_UINT8,                  2, SL_MAX_VERSION),
+	SLE_CONDVAR(Town, exclusive_counter,     SLE_UINT8,                  2, EXCLUSIVE_DL_SL - 1),
+	SLE_CONDVAR(Town, exclusive_counter,     SLE_UINT16,   EXCLUSIVE_DL_SL, SL_MAX_VERSION),
 
 	SLE_CONDVAR(Town, larger_town,           SLE_BOOL,                  56, SL_MAX_VERSION),
 	SLE_CONDVAR(Town, layout,                SLE_UINT8,                113, SL_MAX_VERSION),
diff --git a/src/saveload/vehicle_sl.cpp b/src/saveload/vehicle_sl.cpp
--- a/src/saveload/vehicle_sl.cpp
+++ b/src/saveload/vehicle_sl.cpp
@@ -195,7 +195,7 @@
 			if (a->subtype == AIR_HELICOPTER) a->Next()->Next()->cur_speed = 32;
 
 			/* set new position x,y,z */
-			SetAircraftPosition(a, gp.x, gp.y, GetAircraftFlyingAltitude(a));
+			SetAircraftPosition(a, gp.x, gp.y, GetAircraftMaxAltitude(a->x_pos, a->y_pos, 0));
 		}
 	}
 }
@@ -318,7 +318,7 @@
 			}
 		}
 
-		if (IsSavegameVersionBefore(157)) {
+		if (IsSavegameVersionBefore(KEEP_COMPATIBLE_15_SV)) {
 			/* The road vehicle subtype was converted to a flag. */
 			RoadVehicle *rv;
 			FOR_ALL_ROADVEHICLES(rv) {
@@ -335,7 +335,7 @@
 			}
 		}
 
-		if (IsSavegameVersionBefore(160)) {
+		if (IsSavegameVersionBefore(KEEP_COMPATIBLE_19_SV)) {
 			/* In some old savegames there might be some "crap" stored. */
 			FOR_ALL_VEHICLES(v) {
 				if (!v->IsPrimaryVehicle() && v->type != VEH_DISASTER) {
@@ -491,6 +491,7 @@
 		     SLE_VAR(Vehicle, engine_type,           SLE_UINT16),
 
 		SLE_CONDNULL(2,                                                            0,  151),
+		SLE_CONDNULL(2,                                                            BEFORE_ADDING_PATCHES_SL,  KEEP_COMPATIBLE_9_SV),
 		     SLE_VAR(Vehicle, cur_speed,             SLE_UINT16),
 		     SLE_VAR(Vehicle, subspeed,              SLE_UINT8),
 		     SLE_VAR(Vehicle, acceleration,          SLE_UINT8),
@@ -499,6 +500,7 @@
 		     SLE_VAR(Vehicle, vehstatus,             SLE_UINT8),
 		 SLE_CONDVAR(Vehicle, last_station_visited,  SLE_FILE_U8  | SLE_VAR_U16,   0,   4),
 		 SLE_CONDVAR(Vehicle, last_station_visited,  SLE_UINT16,                   5, SL_MAX_VERSION),
+		 SLE_CONDVAR(Vehicle, last_loading_station,  SLE_UINT16, KEEP_COMPATIBLE_8_SV, SL_MAX_VERSION),
 
 		     SLE_VAR(Vehicle, cargo_type,            SLE_UINT8),
 		 SLE_CONDVAR(Vehicle, cargo_subtype,         SLE_UINT8,                   35, SL_MAX_VERSION),
@@ -557,6 +559,8 @@
 		     SLE_VAR(Vehicle, breakdown_delay,       SLE_UINT8),
 		     SLE_VAR(Vehicle, breakdowns_since_last_service, SLE_UINT8),
 		     SLE_VAR(Vehicle, breakdown_chance,      SLE_UINT8),
+		 SLE_CONDVAR(Vehicle, breakdown_type,        SLE_UINT8,                SL_IB, SL_MAX_VERSION),
+		 SLE_CONDVAR(Vehicle, breakdown_severity,    SLE_UINT8,	               SL_IB, SL_MAX_VERSION),
 		 SLE_CONDVAR(Vehicle, build_year,            SLE_FILE_U8 | SLE_VAR_I32,    0,  30),
 		 SLE_CONDVAR(Vehicle, build_year,            SLE_INT32,                   31, SL_MAX_VERSION),
 
@@ -577,6 +581,9 @@
 		 SLE_CONDVAR(Vehicle, random_bits,           SLE_UINT8,                    2, SL_MAX_VERSION),
 		 SLE_CONDVAR(Vehicle, waiting_triggers,      SLE_UINT8,                    2, SL_MAX_VERSION),
 
+		 SLE_CONDREF(Vehicle, ahead_separation,      REF_VEHICLE,         TIMESEP_SV, SL_MAX_VERSION),
+		 SLE_CONDREF(Vehicle, behind_separation,     REF_VEHICLE,         TIMESEP_SV, SL_MAX_VERSION),
+
 		 SLE_CONDREF(Vehicle, next_shared,           REF_VEHICLE,                  2, SL_MAX_VERSION),
 		SLE_CONDNULL(2,                                                            2,  68),
 		SLE_CONDNULL(4,                                                           69, 100),
@@ -584,6 +591,7 @@
 		 SLE_CONDVAR(Vehicle, group_id,              SLE_UINT16,                  60, SL_MAX_VERSION),
 
 		 SLE_CONDVAR(Vehicle, current_order_time,    SLE_UINT32,                  67, SL_MAX_VERSION),
+		 SLE_CONDVAR(Vehicle, current_loading_time,  SLE_UINT32,          TIMESEP_SV, SL_MAX_VERSION),
 		 SLE_CONDVAR(Vehicle, lateness_counter,      SLE_INT32,                   67, SL_MAX_VERSION),
 
 		SLE_CONDNULL(10,                                                           2, 143), // old reserved space
@@ -608,6 +616,7 @@
 
 		SLE_CONDNULL(2, 2, 19),
 		 SLE_CONDVAR(Train, gv_flags,            SLE_UINT16,                 139, SL_MAX_VERSION),
+ 		 SLE_CONDVAR(Train, signal_speedlimit,   SLE_UINT16,                 SPEED_SIGNALS_SV, SL_MAX_VERSION),
 		SLE_CONDNULL(11, 2, 143), // old reserved space
 
 		     SLE_END()
@@ -658,10 +667,11 @@
 		 SLE_CONDVAR(Aircraft, last_direction,        SLE_UINT8,                    2, SL_MAX_VERSION),
 		 SLE_CONDVAR(Aircraft, number_consecutive_turns, SLE_UINT8,                 2, SL_MAX_VERSION),
 
+		 SLE_CONDVAR(Aircraft, in_max_height_correction, SLE_UINT8,               MORE_HEIGHTLEVEL_SAVEGAME_VERSION, SL_MAX_VERSION),
+		 SLE_CONDVAR(Aircraft, in_min_height_correction, SLE_UINT8,               MORE_HEIGHTLEVEL_SAVEGAME_VERSION, SL_MAX_VERSION),
+
 		 SLE_CONDVAR(Aircraft, turn_counter,          SLE_UINT8,                  136, SL_MAX_VERSION),
-
 		SLE_CONDNULL(13,                                                           2, 143), // old reserved space
-
 		     SLE_END()
 	};
 
@@ -727,6 +737,8 @@
 
 		     SLE_VAR(DisasterVehicle, image_override,            SLE_UINT16),
 		     SLE_VAR(DisasterVehicle, big_ufo_destroyer_target,  SLE_UINT16),
+		 SLE_CONDVAR(DisasterVehicle, in_max_height_correction, SLE_UINT8,       MORE_HEIGHTLEVEL_SAVEGAME_VERSION, SL_MAX_VERSION),
+		 SLE_CONDVAR(DisasterVehicle, in_min_height_correction, SLE_UINT8,       MORE_HEIGHTLEVEL_SAVEGAME_VERSION, SL_MAX_VERSION),
 
 		SLE_CONDNULL(16,                                                           2, 143), // old reserved space
 
@@ -793,6 +805,10 @@
 			v->last_station_visited = INVALID_STATION;
 		}
 
+		if (IsSavegameVersionBefore(KEEP_COMPATIBLE_8_SV)) {
+			v->last_loading_station = INVALID_STATION;
+		}
+
 		if (IsSavegameVersionBefore(5)) {
 			/* Convert the current_order.type (which is a mix of type and flags, because
 			 *  in those versions, they both were 4 bits big) to type and flags */
diff --git a/src/screenshot.cpp b/src/screenshot.cpp
--- a/src/screenshot.cpp
+++ b/src/screenshot.cpp
@@ -792,7 +792,7 @@
 	while (n > 0) {
 		TileIndex ti = TileXY(MapMaxX(), y);
 		for (uint x = MapMaxX(); true; x--) {
-			*buf = 16 * TileHeight(ti);
+			*buf = 1 * TileHeight(ti); // Todo: adjust to allow choosing generated height; 16 is trunk
 			buf++;
 			if (x == 0) break;
 			ti = TILE_ADDXY(ti, -1, 0);
